var mainApp = angular.module('mainApp', ['ngResource']);


mainApp.service("ResourceInterceptor", ['$q', function ($q) {



    //response 请求  拦截
    this.response = function (response) {
        return ResourceSuccessDataHandler(response);
    };

    //request  错误拦截
    this.requestError = function (request) {
        return $q.reject(request);
    };

    //response 错误拦截
    this.responseError = function (response) {
        return ResourceErrorDataHandler(response);
    };


    //资源成功数据处理
    function ResourceSuccessDataHandler(response) {
        if (!response) {
            return $q.resolve(response);
        }
        //进行整理数据
        return parse(response);
    }

    //资源失败数据处理
    function ResourceErrorDataHandler(response) {
        if (!response || !response.config) {
            return $q.reject(response);
        }


        //进行整理数据
        return $q.reject(catch_(response));
    }

    /**
     * 成功数据转换
     */
     function parse(response) {
        if (!response || !response.data) {
            return response;
        }
        if (response.data.status == 0 && !angular.isUndefined(response.data.message)) {
            return catch_(response);
        } else if (response.data.status == 1 && !angular.isUndefined(response.data.message)) {
            if(response.data.data){
                response.data = response.data;
                if(angular.isString(response.data)){
                    response.data = {data : response.data};
                }
            }else{
                response.data = response.data;
            }

            return response;
        }

        return response;
    };
      function catch_(response) {
        var message = null;
        var status = response.status;
        switch (status) {
            case "401":
                message = this.getMessage('401', '您没有获取资源的权限获取登录已失效,请重新登陆后重试。');
                break;
            case "404":
                message = this.getMessage('404', '没有找到相关资源。');
                break;
            case "415":
                message = this.getMessage('415', '请求资源方式不正确,请检查资源请求方式。');
                break;
            case "500":
                message = this.getMessage('500', '资源服务异常。');
                break;
            default:
                //如果登陆已过期
                /*if(response.data && response.data.type == 'no-login111'){
                    if(response.isArray){
                        response.data = [];
                    }else{
                        response.data = {};
                    }

                    return $q.resolve(response)
                }*/

                return $q.reject(response.data);
        }

        return $q.reject(message);
    };
    /**
     * 获错误取消息
     * @param type
     * @param message
     * @returns {{message: *, status: number, type: *}}
     */
    function getMessage(type, message) {
        return {
            message: message,
            status: 0,
            type: type
        };
    };

}]);


mainApp.config(['$locationProvider', '$httpProvider', function ($locationProvider, $httpProvider) {


    $httpProvider.interceptors.push('ResourceInterceptor');

}]);

mainApp.filter('subStr', function ($sce) {
    return function (input,length) {
        if(input==null){
            return "";
        }else{
            if(input.length<=length){
                return input;
            }else{
                var str=input.substr(input.length-2,length);
                return str;
            }

        }
    }
});

mainApp.filter('dateStr', function ($sce) {
    return function (input,param) {
        var length=param.length;
        if(input==null){
            return "";
        }else{
            var str=input.substr(0,length);
            return str;
        }
    }
});

mainApp.filter('timeStr', function ($sce) {
    return function (input) {
        if(input==null){
            return "";
        }else{
            var str=input.substr(5,11);
            return str;
        }
    }
});
mainApp.directive('onFinishRenderFilters', function($timeout) {
    return {
        restrict: 'A',
        link: function(scope, element, attr) {
        	 if(scope.$last === true) {
                    $timeout(function() {
                        scope.$emit('ngRepeatFinished');
                    });
                }
        }
    };
});


function getLocalFileCache(netPath) { 
    var FILE_CACHE_KEY = "filePathCache_" + netPath; 
    var localUrlObj = localStorage.getItem(FILE_CACHE_KEY); 
    return localUrlObj; 
} 
 
function setLocalFileCache(netPath, localPath) { 
    var FILE_CACHE_KEY = "filePathCache_" + netPath; 
    localStorage.setItem(FILE_CACHE_KEY, localPath); 
} 
var Filedownload = function(netPath, callback) { 
    var dtask = plus.downloader.createDownload(netPath, {}, function(d, status) { 
    	console.info(status);
        // 下载完成 
        if (status == 200) { 
            plus.io.resolveLocalFileSystemURL(d.filename, function(entry) { 
                setLocalFileCache(netPath, entry.toLocalURL()); 
                callback(entry.toLocalURL()); //获取当前下载路径 
            }); 
        } 
    }); 
    dtask.start(); 
}; 

mainApp.filter('getImgUrl', function ($sce) {
    return function (input) {
        var netPath=input;
        var localurl= getLocalFileCache(input);
        //console.info("local="+localurl);
        if(localurl==null){
        	Filedownload(netPath,function(url){
        		//console.info(url);
        	})
        	return input;
        }else{
        	//console.info(localurl);
        	return localurl;
        }
    }
});